#!/usr/bin/perl



do 'lib.pl';

my $idx = $in{'idx'};
my $src = $in{'src'};
my $dst = $in{'dst'};
my $service = $in{'service'};
my $port = $in{'port'};
my $active = $in{'active'};
my $hostA = $in{'src'};
my $ipA = $in{'src'};
my $zoneA = $in{'src'};
my $hostB = $in{'dst'};
my $ipB = $in{'dst'};
my $zoneB = $in{'dst'};


my @srcs = split(/\n/,$in{'src'});
my @dsts = split(/\n/,$in{'dst'});


if( $in{'delete'} ) {
	# delete rule
	$whatfailed = 'Fail to delete Rule';
	$fw->DeleteRule( $idx );
} else {
	if( $in{'new'} ) {
		$whatfailed = 'Fail to create new Rule';
	} else {
		$whatfailed = 'Fail to save Rule';
	}

	if( $port ne '' && ($port < 0 || $port > 65535) ) {
		error( 'Wrong Port value (0-65535 or empty)' );
	}
	if($in{'multiple'} eq 1){
	    if($config{'mode'} eq 1){
		foreach $dst (@dsts){
		    chop ($dst);
		    $fw->AddRule( $in{'new'} ? 0 : $idx, $src, $dst, $service, $port, $active );
		    $fw->AddHost($src, $src, $src);
		    if ($dst ne "FIREWALL"){
			$fw->AddHost($dst, $dst, $dst);
		    }
		}
	    }else{
		foreach $src (@srcs){
		    chop ($src);
		    $fw->AddRule( $in{'new'} ? 0 : $idx, $src, $dst, $service, $port, $active );
		    $fw->AddHost($src, $src, $src);
		    if ($hostB ne "FIREWALL"){
			$fw->AddHost($hostB, $ipB, $zoneB);
		    }
		}
	    }
	}else{
	    $fw->AddRule( $in{'new'} ? 0 : $idx, $src, $dst, $service, $port, $active );
	    $fw->AddHost($hostA, $ipA, $zoneA);
	    if ($hostB ne "FIREWALL"){
		$fw->AddHost($hostB, $ipB, $zoneB);
	    }
	}
    }

$fw->SaveFirewall();


redirect( 'rules.cgi' );









